#NoEnv
#NoTrayIcon
#Persistent
#SingleInstance, Off

#include, AHKhttp.ahk
#include, AHKsock.ahk

UpdateAddress := "https://gbatemp.net/download/webui.35479/"
Version := [ "1.4" ]

DetectHiddenWindows, On
SetTitleMatchMode, 3

WindowIds := [ "_AHK_WebUI_1", "_AHK_WebUI_2" ]

if (WinExist(WindowIds[2]))
{
	ExitApp
}

Gui, Show, Hide, % WindowIds[!!A_Args[1] + 1]

OnInitialize()
OnMessage(0x4A, "WM_COPYDATA")

if (!A_Args[1])
{
	RegWrite, % "REG_DWORD", % "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp", % "DefaultSecureProtocols", 0xA00
	Version.Push(GetWebData(UpdateAddress, "<span class=""[^""]*"">([\d\.]+)<\/span>"))
	
	if (Version[2])
	{
		if (Version[1] < Version[2])
		{
			MsgBox, % 32 | 4, % "Update", % "Version " Version[2] " of WebUI is now available.`nWould you like to update now?"
			
			IfMsgBox, Yes
			{
				OpenURL(UpdateAddress)
				ExitApp
			}
		}
	}
	
	Menu, Tray, Tip, % "Lan-Play (WebUI v" Version[1] ")"
	Menu, Tray, NoStandard
	Menu, Tray, Icon
	Menu, Tray, Add, Open WebUI, UI
	Menu, Tray, Add
	Menu, Configuration, Add, Set Binary, Binary
	Menu, Configuration, Add, Set Interface, Interface
	Menu, Configuration, Add, Set Login, Login
	Menu, Configuration, Add, Set Parameters, Parameters
	Menu, Configuration, Add, Set Port, Port
	Menu, Configuration, Add
	Menu, Configuration, Add, Manage Servers, Servers
	Menu, Tray, Add, Configuration, :Configuration
	Menu, Tray, Add
	Menu, Tray, Add, Reload
	Menu, Tray, Add, Exit
	
	OnMessage(0x404, "AHK_NOTIFYICON")
	
	while (true)
	{
		if (!WinExist(WindowIds[2]))
		{
			Run, % """" A_ScriptFullPath """ --Main"
			sleep, 500
		}
		
		if (LastAction)
		{
			Gui, Servers:+LastFoundExist
			
			if (!WinExist())
			{
				SendDataToWindow(LastAction)
				VarSetCapacity(LastAction, 0)
			}
		}
		
		sleep, 100
	}
	
	return
}
else if (!RegExMatch(A_Args[1], "^--Main$"))
{
	ExitApp
}

ServerInfo := []
ServerIndex := 1

for Index, Server in StrSplit(Servers, [ "|" ])
{
	if (RegExMatch(Server, "^([^:]+):(\d+)", Match))
	{
		ServerInfo.Push([ Match1, Match2, 0, GetCountry(Match1), "", 0, 0 ])
	}
}

ResponseText := GetWebData("http://lan-play.com/", "js\/app\.[^\.]+\.js", 0)

if (ResponseText)
{
	ResponseText := GetWebData("http://lan-play.com/" ResponseText, "\[(?:{[^}]+},?)+\];", 0)
	
	if (ResponseText)
	{
		while (RegExMatch(ResponseText, "{[^}]+}", Match))
		{
			ResponseText := StrReplace(ResponseText, Match, "")
			Server := []
			
			while (RegExMatch(Match, "(\w+):([^,}]+)", JSON))
			{
				Server[Format("{:U}", JSON1)] := StrReplace(JSON2, """", "")
				Match := StrReplace(Match, JSON, "")
			}
			
			if ((!Server["IP"]) || (!Server["PORT"]) || (RegExMatch(Server["ACTIVE"], "i)^(0|!1|false)$")))
			{
				continue
			}
			
			ServerInfo.Push([ Server["IP"], Server["PORT"], 0, Server["FLAG"] ? Server["FLAG"] : GetCountry(Server["IP"]), Server["PLATFORM"], 0, 0 ])
		}
	}
}

HttpServer := new HttpServer()
HttpServer.SetPaths({ "/": Func("OnHttpRequest") })
HttpServer.Serve(Port)

TickCount := 0

while (true)
{
	if (!WinExist(WindowIds[1]))
	{
		ExitApp
	}
	
	if (A_TickCount - TickCount > 60000 * 5)
	{
		if (!AHKsock_Connect(0, 0, 0))
		{
			ServerInfo[ServerIndex][6] := A_TickCount
			ServerInfo[ServerIndex][7] := 0
			
			AHKsock_Connect(ServerInfo[ServerIndex][1], ServerInfo[ServerIndex][2], "OnConnect")
			
			ServerIndex++
			TickCount := 0
		}
	}
	
	if (ServerIndex == ServerInfo.Length())
	{
		if (!TickCount)
		{
			ServerIndex := 1
			TickCount := A_TickCount
		}
	}
	
	SendDataToWindow(TickCount ? "Idle" : "Pinging (" ServerIndex "/" ServerInfo.Length() ")")
	sleep, 100
}

GetCountry(Address)
{
	RegExMatch(Address, "^[^:]+", Address)
	AHKsock_GetAddrInfo(Address, Address, true)
	
	return GetWebData("http://www.geoplugin.net/json.gp?ip=" Address, """geoplugin_countryCode"":""([^""]+)""")
}

GetTable()
{
	Global Binary, Server, ServerInfo
	Process, Exist, % SubStr(Binary, InStr(Binary, "\", 0, 0) + 1)
	
	if (!ErrorLevel)
	{
		VarSetCapacity(Server, 0)
	}
	
	VarSetCapacity(Table, 0)
	
	Table := Table "<table id=""Table"">"
	Table := Table "<thead>"
	Table := Table "<tr>"
	Table := Table "<th>Server</th>"
	Table := Table "<th>Online</th>"
	Table := Table "<th>Country</th>"
	Table := Table "<th>Platform</th>"
	Table := Table "<th>Delay (MS)</th>"
	Table := Table "</tr>"
	Table := Table "</thead>"
	Table := Table "<tbody>"
	
	loop, % ServerInfo.Length()
	{
		Delay := (ServerInfo[A_Index][7] - ServerInfo[A_Index][6])
		
		if (Delay > 0)
		{
			Country := ServerInfo[A_Index][4]
			Platform := ServerInfo[A_Index][5]
			
			Table := Table (Server == ServerInfo[A_Index][1] ":" ServerInfo[A_Index][2] ? "<tr class=""Selected"">" : "<tr>")
			Table := Table "<td>" ServerInfo[A_Index][1] ":" ServerInfo[A_Index][2] "</td>"
			Table := Table "<td>" ServerInfo[A_Index][3] "</td>"
			Table := Table "<td>" (Country ? Format("{:U}", Country) : "N/A") "</td>"
			Table := Table "<td>" (Platform ? Format("{:T}", Platform) : "N/A") "</td>"
			Table := Table "<td>" Delay "</td>"
			Table := Table "</tr>"
		}
	}
	
	Table := Table "</tbody>"
	Table := Table "</table>"
	
	return Table
}

GetServer()
{
	Global Server
	return Server
}

SetServer(Address := "")
{
	Global Binary, Interface, Parameters, Server, ServerInfo
	
	Process, Close, % SubStr(Binary, InStr(Binary, "\", 0, 0) + 1)
	Server := Address
	
	loop, % ServerInfo.Length()
	{
		if (Server == ServerInfo[A_Index][1] ":" ServerInfo[A_Index][2])
		{
			Run, % """" Binary """" (Parameters ? " " Parameters : "") " --relay-server-addr """ Server """ --netif """ Interface """", , Min
			break
		}
	}
}

GetWebData(Address, RegexPattern := "", RegexIndex := 1, Timeout := 60000)
{
	ComObjError(false)
	 
	WinHttp := ComObjCreate("WinHttp.WinHttpRequest.5.1")
	WinHttp.SetTimeouts(Timeout / 4, Timeout / 4, Timeout / 4, Timeout / 4)
	WinHttp.Open("GET", Address)
	WinHttp.Send()
	
	return (RegexPattern ? (RegExMatch(WinHttp.ResponseText, RegexPattern, Match) ? (RegexIndex > 0 ? Match%RegexIndex% : Match) : false) : WinHttp.ResponseText)
}

GetVersion(Index := 1)
{
	Global Version
	return Version[Index]
}

OnConnect(Event, Socket = 0, Address = 0, IP = 0, Port = 0)
{
	if (Event == "CONNECTED")
	{
		Global ServerInfo
		
		loop, % ServerInfo.Length()
		{
			if (Address == ServerInfo[A_Index][1])
			{
				ServerInfo[A_Index][7] := (Socket != -1 ? A_TickCount : ServerInfo[A_Index][6] + 21000)
				
				if (ServerInfo[A_Index][7] - ServerInfo[A_Index][6] < 21000)
				{
					ServerInfo[A_Index][3] := GetWebData("http://" ServerInfo[A_Index][1] ":" ServerInfo[A_Index][2] "/info", """online"":(\d+)", 1, 20000)
				}
				
				break
			}
		}
	}
	
	if (Socket != -1)
	{
		AHksock_Close(Socket)
	}
}

OnHttpRequest(ByRef HttpRequest, ByRef HttpResponse)
{
	Global Login, Server, ServerInfo, Version
	
	if ((Login) && (Login != Base64_Decode(SubStr(HttpRequest.headers["Authorization"], 6))))
	{
		HttpResponse.headers["WWW-Authenticate"] := "Basic realm=""WebUI"""
		HttpResponse.SetBodyText("Invalid credentials. Please try again.")
		HttpResponse.status := 401
		
		return
	}
	
	if (HttpRequest.method == "POST")
	{
		Invoke := HttpRequest.queries["Invoke"]
		
		if (RegExMatch(Invoke, "i)^(Get(?!Country|WebData)|Set)\w+$"))
		{
			Invocation := Func(Invoke)
			
			if ((Invocation) && (!Invocation.IsBuiltIn))
			{
				HttpResponse.SetBodyText(HttpRequest.body ? Invocation.Call(HttpRequest.body) : Invocation.Call())
			}
		}
	}
	else
	{
		FileRead, Template, % "WebUI.html"
		
		for Key, Value in { "Login": Login, "Server": Server, "Table": GetTable(), "Version": Version[1] }
		{
			Template := StrReplace(Template, "<!-- " Key " !-->", Value)
		}
		
		HttpResponse.SetBodyText(Template)
	}
	
	HttpResponse.status := 200
}

OnInitialize()
{
	Global
	
	IniRead, Binary, % "WebUI.ini", % "Configuration", % "Binary", % A_Space
	IniRead, Interface, % "WebUI.ini", % "Configuration", % "Interface", % A_Space
	IniRead, Login, % "WebUI.ini", % "Configuration", % "Login", % A_Space
	IniRead, Parameters, % "WebUI.ini", % "Configuration", % "Parameters", % "--fake-internet"
	IniRead, Port, % "WebUI.ini", % "Configuration", % "Port", % 80
	IniRead, Servers, % "WebUI.ini", % "Configuration", % "Servers", % A_Space
	
	if ((!Binary) || (!FileExist(Binary)))
	{
		GoSub, Binary
	}
	
	if (!Interface)
	{
		GoSub, Interface
	}
	
	while ((Login) && (!InStr(Login, ":")))
	{
		GoSub, Login
	}
	
	if (Parameters)
	{
		Parameters := ParseParameters(Parameters)
	}
	
	while ((Port < 1) || (Port > 65535))
	{
		GoSub, Port
	}
	
	if (!FileExist("WebUI.html"))
	{
		MsgBox, 48, % "Error", % "Unable to locate HTML template.`nPlease place WebUI.html in the same directory of WebUI and try again!"
		ExitApp
	}
}

OpenURL(Address)
{
	for Index, ClassName in [ "MozillaUIWindowClass", "MozillaWindowClass", "Chrome_WidgetWin_1", "IEFrame" ]
	{
		WinGet, ProcessPath, ProcessPath, % "ahk_class" ClassName
		
		if (ProcessPath)
		{
			break
		}
		
		VarSetCapacity(ProcessPath, 0)
	}
	
	Run, % (ProcessPath ? ProcessPath A_Space : ProcessPath) Address
}

ParseParameters(Input)
{
	Local Parameters := ""
	
	while (RegExMatch(Input, "i)(--(?!help|version|relay-server-addr|netif|list-if)[\w-]+)(?: (?!--)(?:""([^""]*)""|([^\s]+)))?", Match))
	{
		Parameters := Parameters (Parameters ? " " : "") Match1
		
		if ((Match2) || (Match3))
		{
			Parameters := Parameters " " """" (Match3 ? Match3 : Match2) """"
		}
		
		Input := StrReplace(Input, Match, "")
	}
	
	return Parameters
}

StrJoin(Input, Delimiters := " ", OmitChars := "")
{
	for Index, Split in Input
	{
		Input := Input (Index > 1 ? Delimiters : "") Trim(Split, OmitChars)
	}
	
	return Input
}

AHK_NOTIFYICON(wParam, lParam) 
{
	if (lParam == 0x203)
	{
		GoSub, UI
	}
	
	return
}

WM_COPYDATA(wParam, lParam)
{
	Data := StrGet(NumGet(lParam + 2 * A_PtrSize))
	
	if (!A_Args[1])
	{
		Global Version
		Menu, Tray, Tip, % "Lan-Play (WebUI v" Version[1] ")`nStatus: " Data
	}
	else
	{
		OnInitialize()
	}
	
	return true
}

Base64_Encode(Input)
{
	Local Buffer, Binary, Size
	
	loop, 2
	{
		VarSetCapacity(Size ? Buffer : Binary, Size ? Size << 1 : StrPut(Input, "UTF-8"))
		
		if (!DllCall("Crypt32\CryptBinaryToString", "Ptr", &Binary, "UInt", StrPut(Input, &Binary, "UTF-8") - 1, "UInt", 0x1, "Ptr", A_Index > 1 ? &Buffer : 0, "UInt*", Size))
		{
			return
		}
	}
	
	return StrGet(&Buffer)
}

Base64_Decode(Input)
{
	Local Buffer, Size
	
	loop, 2
	{
		VarSetCapacity(Buffer, Size, 0)
		
		if (!DllCall("Crypt32\CryptStringToBinary", "Ptr", &Input, "UInt", 0, "UInt", 0x1, "Ptr", A_Index > 1 ? &Buffer : 0, "UInt*", Size, "Ptr", 0, "Ptr", 0))
		{
			return
		}
	}
	
	return StrGet(&Buffer, Size, "UTF-8")
}

SendDataToWindow(ByRef Input)
{
	Global WindowIds
	
	VarSetCapacity(CopyDataStruct, 3 * A_PtrSize)
	NumPut((StrLen(Input) + 1) * (A_IsUnicode ? 2 : 1), CopyDataStruct, A_PtrSize)
	NumPut(&Input, CopyDataStruct, 2 * A_PtrSize)
	
	SendMessage, 0x4A, 0, &CopyDataStruct, , % WindowIds[!A_Args[1] + 1]
	return ErrorLevel
}

;
; Credits to Cyruz for the StdoutToVar_CreateProcess function:
; (https://www.autohotkey.com/boards/viewtopic.php?t=791)
;

StdoutToVar_CreateProcess(sCmd, sEncoding := "CP0", sDir := "", ByRef nExitCode := 0)
{
	DllCall("CreatePipe", PtrP, hStdOutRd, PtrP, hStdOutWr, Ptr, 0, UInt, 0)
	DllCall("SetHandleInformation", Ptr, hStdOutWr, UInt, 1, UInt, 1)
	
	VarSetCapacity(pi, A_PtrSize == 4 ? 16 : 24, 0)
	
	NumPut(VarSetCapacity(si, A_PtrSize == 4 ? 68 : 104, 0), si, 0, "UInt")
	NumPut(0x100, si, A_PtrSize == 4 ? 44 : 60, "UInt")
	NumPut(hStdOutWr, si, A_PtrSize == 4 ? 60 : 88, "Ptr")
	NumPut(hStdOutWr, si, A_PtrSize == 4 ? 64 : 96, "Ptr")
	
	if (!DllCall("CreateProcess", Ptr, 0, Ptr, &sCmd, Ptr, 0, Ptr, 0, Int, true, UInt, 0x08000000, Ptr, 0, Ptr, sDir ? &sDir : 0, Ptr, &si, Ptr, &pi))
	{
		Return "", DllCall("CloseHandle", Ptr, hStdOutWr), DllCall("CloseHandle", Ptr, hStdOutRd)
	}
	
	DllCall("CloseHandle", Ptr, hStdOutWr)
	
	while (true)
	{
		if (!DllCall("PeekNamedPipe", Ptr, hStdOutRd, Ptr, 0, UInt, 0, Ptr, 0, UIntP, nTot, Ptr, 0))
		{
			break
		}
		
		if (!nTot)
		{
		    sleep, 100
		    continue
		}
		
		VarSetCapacity(sTemp, nTot + 1)
		DllCall("ReadFile", Ptr, hStdOutRd, Ptr, &sTemp, UInt, nTot, PtrP, nSize, Ptr, 0)
		
		sOutput .= StrGet(&sTemp, nSize, sEncoding)
	}
	
	DllCall("GetExitCodeProcess", Ptr, NumGet(pi, 0), UIntP, nExitCode)
	DllCall("CloseHandle", Ptr, NumGet(pi, 0))
	DllCall("CloseHandle", Ptr, NumGet(pi, A_PtrSize))
	DllCall("CloseHandle", Ptr, hStdOutRd)
	
	return sOutput
}

UI:
	OpenURL("http://127.0.0.1:" Port)
	return
Reload:
	Reload
	return
Exit:
	ExitApp
Binary:
	FileSelectFile, Result, 3, % Binary , % "Open", % "Lan-Play Binary (lan-play*.exe)"
	
	if (!Result)
	{
		if (WinExist(WindowIds[1]))
		{
			return
		}
		
		ExitApp
	}
	
	LastAction := A_ThisLabel
	Binary := Result
	
	IniWrite, % Binary, % "WebUI.ini", % "Configuration", % "Binary"
	return
Interface:
	VarSetCapacity(Result, 0)
	Output := StdoutToVar_CreateProcess(Binary " --list-if")
	
	if (!RegExMatch(Output, "(\d+)\.\s*(\\Device\\[^\s]+)"))
	{
		IniDelete, % "WebUI.ini", % "Configuration", % "Binary"
		ExitApp
	}
	
	while (!Result)
	{
		Index := 0
		StrReplace(Output, "\Device\" , , ErrorLevel)
		
		Gui, +AlwaysOnTop +LastFound +OwnDialogs
		InputBox, Result, % "Select Interface", % Output, , 600, 150 + (ErrorLevel * 35), , , , , % Interface
		
		if (ErrorLevel)
		{
			if (WinExist(WindowIds[1]))
			{
				return
			}
			
			ExitApp
		}
		
		while (Index := RegExMatch(Output, "(\d+)\.\s*(\\Device\\[^\s]+)", Match, Index + 1))
		{
			if ((Result == Match1) || (Result == Match2))
			{
				Result := Match2
			}
		}
	}
	
	LastAction := A_ThisLabel
	Interface := Result
	
	IniWrite, % Interface, % "WebUI.ini", % "Configuration", % "Interface"
	return
Login:
	VarSetCapacity(Result, 0)
	
	while (!InStr(Result, ":"))
	{
		Gui, +AlwaysOnTop +LastFound +OwnDialogs
		InputBox, Result, % "Enter Login", % "Please enter a login [USER:PASS]:", , 250, 150, , , , , % Result ? Result : Login
		
		if ((ErrorLevel) || (Result == Login))
		{
			return
		}
		
		if (!Result)
		{
			break
		}
	}
	
	
	LastAction := A_ThisLabel
	Login := Result
	
	IniWrite, % Login, % "WebUI.ini", % "Configuration", % "Login"
	return
Parameters:
	VarSetCapacity(Result, 0)
	
	Gui, +AlwaysOnTop +LastFound +OwnDialogs
	InputBox, Result, % "Enter Parameters", % "Please enter additional Lan-Play parameters:", , 300, 150, , , , , % Parameters
	
	if ((ErrorLevel) || (Result == Parameters))
	{
		return
	}
	
	
	LastAction := A_ThisLabel
	Parameters := ParseParameters(Result)
	
	IniWrite, % Parameters, % "WebUI.ini", % "Configuration", % "Parameters"
	return
Port:
	VarSetCapacity(Result, 0)
	
	while ((Result < 1) || (Result > 65535))
	{
		Gui, +AlwaysOnTop +LastFound +OwnDialogs
		InputBox, Result, % "Enter Port", % "Please enter a valid port [1-65535]:", , 250, 150, , , , , % Port
		
		if ((ErrorLevel) || (Result == Port))
		{
			return
		}
	}
	
	Port := Result
	IniWrite, % Port, % "WebUI.ini", % "Configuration", % "Port"
	
	Reload
	return
Servers:
	Gui, Servers:New, +AlwaysOnTop +Resize
	Gui, Add, ListBox, vListBox1 gAdd, % Servers
	Gui, Add, Button, vButton1 gAdd, Add
	Gui, Add, Button, vButton2 gRemove, Remove
	Gui, Show, w300 h150, % "Manage Servers"
	Menu, Tray, Disable, Configuration
	
	return
ServersGuiSize:
	GuiControl, Move, ListBox1, % "x5" "y5" "w" (A_GuiWidth - 10) "h" (A_GuiHeight - 35)
	GuiControl, Move, Button1, % "x5" "y" (A_GuiHeight - 30) "w" ((A_GuiWidth / 2) - 10) "h25"
	GuiControl, Move, Button2, % "x" ((A_GuiWidth / 2) + 5) "y" (A_GuiHeight - 30) "w" ((A_GuiWidth / 2) - 10) "h25"
	
	return
ServersGuiClose:
	if (LastAction)
	{
		Reload
	}
	
	Menu, Tray, Enable, Configuration
	Gui, Destroy
	
	return
Add:
	ControlGet, List, List, , ListBox1, A
	
	if (A_GuiControl == "ListBox1")
	{
		if (A_GuiEvent != "DoubleClick")
		{
			return
		}
		
		Gui, Submit, NoHide
	}
	
	VarSetCapacity(Result, 0)
	List := StrSplit(List, "`n")
	
	while (!RegExMatch(Result, "^([^:]+):(\d+)"))
	{
		Gui, +AlwaysOnTop +LastFound +OwnDialogs
		InputBox, Result, % (A_GuiControl == "ListBox1" ? "Edit" : "Add") " Server", % "Please enter a server:", , 250, 150, , , , , % (A_GuiControl == "ListBox1" ? (!Result ? ListBox1 : Result) : Result)
		
		if (ErrorLevel)
		{
			return
		}
	}
	
	loop, % List.Length()
	{
		if (A_GuiControl == "ListBox1")
		{
			if (ListBox1 == List[A_Index])
			{
				List.RemoveAt(A_Index)
				continue
			}
		}
		
		if (Format("{:U}", Result) == Format("{:U}", List[A_Index]))
		{
			return
		}
	}
	
	List.Push(Result)
	Servers := StrJoin(List, "|")
	
	LastAction := A_ThisLabel
	IniWrite, % Servers, % "WebUI.ini", % "Configuration", % "Servers"
	
	GuiControl, , ListBox1 , % "|" Servers
	return
Remove:
	ControlGet, List, List, , ListBox1, A
	
	List := StrSplit(List, "`n")
	Gui, Submit, NoHide
	
	loop, % List.Length()
	{
		if (ListBox1 == List[A_Index])
		{
			List.RemoveAt(A_Index)
			
			Servers := StrJoin(List, "|")
			IniWrite, % Servers, % "WebUI.ini", % "Configuration", % "Servers"
			
			break
		}
	}
	
	LastAction := A_ThisLabel
	GuiControl, , ListBox1 , % "|" Servers
	
	return